<template>
  <form class="form" novalidate @submit.prevent="handleSubmit">
    <FormRow>
      <FormInput
        v-model="cours.code"
        type="text"
        name="Code"
        ref="addFormInputRef"
        @input="
          (event : Event) => {
            cours.code = event.target.value.toUpperCase();
          }
        "
        :label="t('cours.code')"
        @validated="handleValidation"
        :rules="ruleForCode"
      />
      <FormInput
        v-model="cours.nomCours"
        type="text"
        name="Nom de Cours"
        @input="
          (event : Event) => {
                cours.nomCours = event.target.value.toUpperCase();
          }
        "
        ref="addFormInputRef"
        :label="t('cours.nomCours')"
        @validated="handleValidation"
        :rules="ruleForNomCours"
      />
    </FormRow>
    <button
      v-if="!props.cours"
      class="form__submit btn btn--fullscreen"
      type="submit"
    >
      {{ t("global.add") }}
    </button>
    <button v-else class="form__submit btn btn--fullscreen" type="submit">
      {{ t("global.save") }}
    </button>
  </form>
</template>

<script lang="ts" setup>
import FormRow from "@/components/forms/FormRow.vue";
import FormInput from "@/components/forms/FormInput.vue";
import { ref } from "vue";
import { useI18n } from "vue3-i18n";
import { notifyError } from "@/notify";
import { Status } from "@/validation";
import { Cours } from "../../types/entities/cours";
import { notify } from "@kyvg/vue3-notification";
import { useMemberService } from "@/inversify.config";
import {Rule, mustMatchCodeFormat, mustMatchLengthNomCours} from "@/validation/rules";
// eslint-disable-next-line no-undef
const props = defineProps<{ cours: Cours }>();
// eslint-disable-next-line
const emits = defineEmits<{ (event: "formSubmit", cours: Cours): void }>();
const memberService = useMemberService();
const { t } = useI18n();
const cours = ref<Cours>(props.cours ?? {});
const formInputs = ref<any[]>([]);
const inputsValidationStatuses: any = {};
const ruleForCode: Rule[] = [mustMatchCodeFormat];
const ruleForNomCours: Rule[] = [mustMatchLengthNomCours];


function addFormInputRef(ref: typeof FormInput) {
  if (!formInputs.value.includes(ref) && ref) formInputs.value.push(ref);
}
async function handleValidation(name: string, validationStatus: Status) {
  inputsValidationStatuses[name] = validationStatus.valid;
}
async function handleSubmit() {
  formInputs.value.forEach((x: typeof FormInput) => x.validateInput());
  if (Object.values(inputsValidationStatuses).some((x) => x === false)) {
    console.log(inputsValidationStatuses);
    notifyError(t("global.formErrorNotification"));
    return;
  }
  var users = await memberService.getAllMembers();
  var userConncte = await memberService.getCurrentMember();
  const user = users.find((x) => x.email === userConncte?.email);
  cours.value.idMembre = user?.id;

  emits("formSubmit", cours.value);
}
</script>
